'use strict';

exports.__esModule = true;

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

// eslint-disable-next-line
Array.prototype.instanceofArray = true;

var getChildren = function getChildren(arr) {
  var result = new window.asmDom.VNodePtrVector();
  for (var i = 0; i < arr.length; i++) {
    if (typeof arr[i] === 'string') {
      result.push_back(window.asmDom._h_ti(arr[i], true));
    } else if (arr[i] !== false && arr[i] !== null && arr[i] !== undefined) {
      result.push_back(arr[i]);
    }
  }
  return result;
};

var getData = function getData(obj) {
  var hasRaws = obj.raw !== undefined;
  var hasEvents = false;

  var ref = void 0;
  var attrs = new window.asmDom.MapStringString();
  var raw = obj.raw !== undefined ? obj.raw : {};
  var events = {};

  if (typeof obj.className === 'string') attrs.set('class', obj.className);
  var keys = Object.keys(obj);
  var i = keys.length;
  while (i--) {
    var key = keys[i];
    var value = obj[key];
    if (key === 'value' || key === 'checked') {
      raw[key] = value;
      hasRaws = true;
    } else if (typeof value === 'function') {
      if (key === 'ref') {
        ref = value;
      } else {
        events[key.replace(/^on/, '')] = value;
        hasEvents = true;
      }
    } else if (value !== false && key !== 'raw' && key !== 'className') {
      // eslint-disable-next-line
      attrs.set(key, '' + value);
    }
  }

  return {
    ref: ref,
    raw: hasRaws ? raw : undefined,
    events: hasEvents ? events : undefined,
    attrs: attrs
  };
};

exports['default'] = function (a, b, c, d) {
  var result = void 0;
  var data = void 0;
  if (b === undefined) {
    result = window.asmDom._h_s(a);
  } else if (c === undefined) {
    if (b.instanceofArray === true) {
      result = window.asmDom._h_sc(a, b = getChildren(b));
      b['delete']();
    } else {
      switch (typeof b === 'undefined' ? 'undefined' : _typeof(b)) {
        case 'boolean':
          result = window.asmDom._h_ti(a, b);
          break;
        case 'string':
          result = window.asmDom._h_st(a, b);
          break;
        case 'number':
          result = window.asmDom._h_sn(a, b);
          break;
        case 'object':
          data = getData(b);
          result = window.asmDom._h_sd(a, data.attrs);
          break;
        default:
          throw new Error('Invalid argument: ', b);
      }
    }
  } else if (d === undefined) {
    data = getData(b);
    if (c.instanceofArray === true) {
      result = window.asmDom._h_sdc(a, data.attrs, c = getChildren(c));
      c['delete']();
    } else {
      switch (typeof c === 'undefined' ? 'undefined' : _typeof(c)) {
        case 'string':
          result = window.asmDom._h_sdt(a, data.attrs, c);
          break;
        case 'number':
          result = window.asmDom._h_sdn(a, data.attrs, c);
          break;
        default:
          throw new Error('Invalid argument: ', c);
      }
    }
  } else {
    throw new Error('Invalid arguments provided to h function');
  }
  if (data !== undefined) {
    data.attrs['delete']();
    if (data.raw !== undefined || data.events !== undefined || data.ref !== undefined) {
      delete data.attrs;
      window.asmDomHelpers.vnodesData[result] = data;
    }
  }
  return result;
};
